MODULE ModIntegrand
implicit none


CONTAINS

 


FUNCTION VegasIntegrand1(x,VgsWgt,res)
implicit none
integer :: VegasIntegrand1
real(8) ::  x(*),res(*),VgsWgt
double complex :: prop1,aux1,dummy
double precision :: spike1,step1
double precision,parameter :: Msq=(91.19*91.19);
double precision,parameter ::  Gamma = 2.0; 
double precision,parameter ::  eps=0.3; 
integer :: i,j
double complex,parameter :: cI=(0d0,1d0)
double precision, parameter :: Pi=3.14159265d0
    

  prop1  = 1.d0/(x(1)**2 - x(2)**2 - Msq + cI*Gamma*dsqrt(Msq))
  spike1 = dabs(x(1)-x(3))**(eps-1.0d0)
  aux1   = x(5)**2*dcos(2.0d0*PI*x(5))**2 + dtanh(x(5))
  if( x(6) .gt. 0.5d0 ) then
     step1=x(6)
  else 
     step1 = 0.0d0
  endif
    
    
  i=1
  do while( i .le. x(6)*1000 ) 
     i=i+1
     i = i + int(i*10*dsin(x(5))**2)

     dummy = 1.0d0 - 1.2d0*cI
     if( x(3).lt.0.3d0 ) dummy = (1.0d0+3.3d0*cI) * dcos(x(1))
     dummy = dummy**2.5d0
     if( x(6)+x(2) .lt. 0.7d0 ) dummy = dummy + (1.0d0+3.3d0*cI) * dexp(x(1)**2)
     dummy = dummy**2.5d0
     dummy = dummy + (4.0d0+3.3d0*cI) * dexp(x(1)**2)
     if( x(3)*x(2) .gt. 0.1d0 ) dummy = cdabs(dummy)**0.6d0
     dummy = dummy + (9.0d0+6.3d0*cI) * dsinh(x(1)**2)
     if( mod(i,4).eq.0 ) dummy = dummy + (6.0d0+1.3d0*cI) * dtanh(x(1)**2)
  
     j=0;
     do while( j .lt. 100  ) 
           j=j+1
           if( dsin(cdabs(dummy)*2d0*Pi).gt.0d0 ) dummy = dummy + (2.0d0+2.3d0*cI) * dlog(x(1)**2+0.1d0) * dcos(2.0d0*PI*j)
     enddo
     
  enddo 
  
    
  res(1) =  dreal(dummy) * i * cdabs(prop1)**2 * spike1 * aux1 * step1 * 1000d0
   
   
VegasIntegrand1=0
RETURN
END FUNCTION









FUNCTION VegasIntegrand1_CUBA(ndim,yRnd,ncomp,res,userdata,nvec,core)
implicit none
integer :: VegasIntegrand1_CUBA
integer ndim, ncomp, nvec, core,userdata
double precision yRnd(ndim,nvec), res(ncomp,nvec),x1,x2,VgsWgt,Dummy(1:1)



   x1 = yRnd(1,1)*40d0-20d0
   x2 = yRnd(2,1)*40d0-20d0

   res(1,1) = VegasIntegrand1((/x1,x2/),VgsWgt,Dummy)
   res(1,1) = dummy(1)*40*40
    
  
VegasIntegrand1_CUBA=0
RETURN
END FUNCTION






END MODULE ModIntegrand




